unit TengForm1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, StdCtrls, clipbrd, Printers, TengForm2, otte; 

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N1: TMenuItem;
    Print1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Undo1: TMenuItem;
    N2: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    N3: TMenuItem;
    SelectAll1: TMenuItem;
    N4: TMenuItem;
    Transcribe1: TMenuItem;
    TranscribeBack1: TMenuItem;
    Text1: TMenuItem;
    AlignLeft1: TMenuItem;
    AlignRight1: TMenuItem;
    AlignCenter1: TMenuItem;
    N5: TMenuItem;
    WordWrap1: TMenuItem;
    ReadOnly1: TMenuItem;
    Option1: TMenuItem;
    Font1: TMenuItem;
    CountChars1: TMenuItem;
    Mode1: TMenuItem;
    Numbers1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Clear1: TMenuItem;
    N6: TMenuItem;
    Cut2: TMenuItem;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    N7: TMenuItem;
    SelectAll2: TMenuItem;      
    OpenDialog1: TOpenDialog; //For files
    SaveDialog1: TSaveDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    FontDialog1: TFontDialog;
    OpenDialog2: TOpenDialog; //For modes
    StatusBar1: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Memo1Change(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure DoTranscribe(TranscribeBack: boolean);
    procedure Transcribe1Click(Sender: TObject);
    procedure TranscribeBack1Click(Sender: TObject);
    procedure AlignLeft1Click(Sender: TObject);
    procedure AlignRight1Click(Sender: TObject);
    procedure AlignCenter1Click(Sender: TObject);
    procedure WordWrap1Click(Sender: TObject);
    procedure ReadOnly1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure CountChars1Click(Sender: TObject);
    procedure Mode1Click(Sender: TObject);
    procedure Numbers1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure Cut2Click(Sender: TObject);
    procedure Copy2Click(Sender: TObject);
    procedure Paste2Click(Sender: TObject);
    procedure SelectAll2Click(Sender: TObject);
  private
    trans: TotteTranscriber;
    filename: string;
    modified: bool;
  public
    function SaveChanges: Boolean;
    function Save: Boolean;
    function SaveAs: Boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//-----------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  if ParamCount <> 0 then Memo1.Lines.LoadFromFile(ParamStr(1));

  trans := TotteTranscriber.create;

  OpenDialog1.Filter := 'Text Document (*.txt)|*.txt';
  OpenDialog1.InitialDir := GetCurrentDir();
  OpenDialog1.DefaultExt := '.txt';

  OpenDialog2.Filter := 'Tengwar Mode (*.mod)|*.mod';
  OpenDialog2.InitialDir := GetCurrentDir();
  OpenDialog2.DefaultExt := '.mod';

  SaveDialog1.Filter := 'Text Document (*.txt)|*.txt';
  SaveDialog1.InitialDir := GetCurrentDir();
  SaveDialog1.DefaultExt := '.txt';

  Memo1.ScrollBars := ssVertical;
  Memo1.WordWrap := True;
  Memo1.SelStart := 0;
  WordWrap1.Checked := True;
  AlignLeft1.Checked := True;
  Form1.Caption := 'Teng - '+'Untitled';
  filename := 'Untitled';
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormResize(Sender: TObject); { What it is needed for?? }
begin
  Memo1.Width := Form1.ClientWidth + 1;
  Memo1.Height := Form1.ClientHeight + 1;
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  trans.destroy;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Memo1Change(Sender: TObject);
begin
  modified := True;
end;

//-----------------------------------------------------------------------------
function TForm1.SaveChanges: Boolean;
var code: Integer;
begin
  SaveChanges := True;
  code := MessageDlg (filename + ' has changed. Do you want to save the changes?',
  mtInformation, mbYesNoCancel, 0);
  if (code = IDYES) then SaveChanges := Save;
  if (code = IDCANCEL) then SaveChanges := False;
end;

//-----------------------------------------------------------------------------
function TForm1.Save: Boolean;
begin
  if filename = '' then
    Save := SaveAs
  else begin
    modified := False;
    Memo1.Lines.SaveToFile(filename);
    Save := True;
  end;
end;

//-----------------------------------------------------------------------------
function TForm1.SaveAs: Boolean;
begin
  SaveDialog1.FileName := filename;
  if SaveDialog1.Execute then begin
    filename := SaveDialog1.FileName;
    Memo1.Lines.SaveToFile(filename);
    modified := False;
    Form1.Caption := 'Teng - '+SaveDialog1.filename;
    SaveAs := True;
  end
  else SaveAs := False;
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if modified then
    if SaveChanges then CanClose := True
    else CanClose := False
  else
    CanClose := True;
end;

//-----------------------------------------------------------------------------
procedure TForm1.New1Click(Sender: TObject);
begin
  Memo1.Text := '';
  modified := False;
  filename := 'Untitled';
  Form1.Caption := 'Teng - '+'Untitled';
end;

//-----------------------------------------------------------------------------
procedure TForm1.Open1Click(Sender: TObject);
begin
  if OpenDialog1.Execute Then begin
    Form1.Caption := 'Teng - '+OpenDialog1.FileName;
    Memo1.Lines.LoadFromFile(OpenDialog1.Filename);
    Memo1.SelStart := 0;
    filename := OpenDialog1.FileName;
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Save1Click(Sender: TObject);
begin
  if modified then Save;
end;

//-----------------------------------------------------------------------------
procedure TForm1.SaveAs1Click(Sender: TObject);
begin
  SaveAs;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Print1Click(Sender: TObject);
var
  sMemo : String;
  fname : TextFile;
  x : Integer;
begin
  sMemo := Memo1.Text;
  if Length(Trim(sMemo)) = 0 then
    MessageDlg('No Text To Print',mtError,[MBOK],0)
  else if PrinterSetupDialog1.Execute then begin
    Printer.Canvas.Font.Assign(Memo1.Font);
    AssignPrn(fname);
    Rewrite(fname);
    try
      for x := 0 to Memo1.Lines.Count - 1 do
        Writeln(fname, Memo1.Lines[x]);
    finally
      CloseFile(fname);
    end;
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Edit1Click(Sender: TObject);
var sMemo : String;
begin
  {if some text is selected in the memo,
  enable the cut and copy commands}
  if Memo1.SelLength > 0 then begin
    Copy1.Enabled := True;
    Cut1.Enabled := True;
  end
  else begin
    Copy1.Enabled := False;
    Cut1.Enabled := False;
  end;

  {if the clipboard contains some text,
  enable the Paste command}
  if Clipboard.HasFormat (CF_TEXT) then
    Paste1.Enabled := True
  else
    Paste1.Enabled := False;

  sMemo := Memo1.Text;

  if Length(Trim(sMemo)) > 0 then begin
    Undo1.Enabled := True;
    SelectAll1.Enabled := True;
  end
  else begin
    SelectAll1.Enabled := False;
    Undo1.Enabled := False;
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Undo1Click(Sender: TObject);
begin
  SendMessage(Memo1.Handle,WM_UNDO,0,0);
end;

//-----------------------------------------------------------------------------
procedure TForm1.Cut1Click(Sender: TObject);
begin
  Memo1.CutToClipboard;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Copy1Click(Sender: TObject);
begin
  Memo1.CopyToClipboard;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Paste1Click(Sender: TObject);
begin
  Memo1.PasteFromClipboard;
end;

//-----------------------------------------------------------------------------
procedure TForm1.SelectAll1Click(Sender: TObject);
begin
  Memo1.SelectAll;
end;

//-----------------------------------------------------------------------------
procedure TForm1.DoTranscribe(TranscribeBack: boolean);
begin
  trans.TxtAll := not Options.TreatSep.Checked;
  trans.RevNum := Options.RevNum.Checked;
  trans.B12Num := Options.Duodecimal.Checked;
  trans.CirNum := Options.CirNum.Checked;
  trans.BarNum := Options.DashNum.Checked;
  trans.DotNum := Options.DotNum.Checked;

  if length(Trans.mode.clauses) = 0 then
    Mode1Click(self);

  Memo1.Cursor := crHourGlass;
  Memo1.Lines.BeginUpdate;

  if Memo1.SelText <> '' then
    Memo1.SelText := trans.TranscribeLine(transcribeBack, Memo1.SelText)
  else Memo1.Text := trans.TranscribeLine(TranscribeBack, Memo1.Text);

  Memo1.Lines.EndUpdate;
  Memo1.Cursor := crDefault;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Transcribe1Click(Sender: TObject);
begin
  DoTranscribe(false);
end;

//-----------------------------------------------------------------------------
procedure TForm1.TranscribeBack1Click(Sender: TObject);
begin
  DoTranscribe(true);
end;

//-----------------------------------------------------------------------------
procedure TForm1.AlignLeft1Click(Sender: TObject);
begin
  Memo1.Alignment := taLeftJustify;
  AlignLeft1.Checked := True;
  AlignRight1.Checked := False;
  AlignCenter1.Checked := False;
end;

//-----------------------------------------------------------------------------
procedure TForm1.AlignRight1Click(Sender: TObject);
begin
  Memo1.Alignment := taRightJustify;
  AlignLeft1.Checked := False;
  AlignRight1.Checked := True;
  AlignCenter1.Checked := False;
end;

//-----------------------------------------------------------------------------
procedure TForm1.AlignCenter1Click(Sender: TObject);
begin
  Memo1.Alignment := taCenter;
  AlignLeft1.Checked := False;
  AlignRight1.Checked := False;
  AlignCenter1.Checked := True;
end;

//-----------------------------------------------------------------------------
procedure TForm1.WordWrap1Click(Sender: TObject);
begin
  if Memo1.WordWrap then begin
    Memo1.WordWrap := False;
    WordWrap1.Checked := False;
    Memo1.ScrollBars := ssBoth;
  end
  else begin
    Memo1.WordWrap := True;
    WordWrap1.Checked := True;
    Memo1.ScrollBars := ssVertical;
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.ReadOnly1Click(Sender: TObject);
begin
  Memo1.ReadOnly := NOT Memo1.ReadOnly;
  ReadOnly1.Checked := NOT ReadOnly1.Checked
end;

//-----------------------------------------------------------------------------
procedure TForm1.Font1Click(Sender: TObject);
begin
  FontDialog1.Font := Memo1.Font;
  if FontDialog1.Execute then
    Memo1.Font := FontDialog1.Font;
end;

//-----------------------------------------------------------------------------
procedure TForm1.CountChars1Click(Sender: TObject);
var txt : String;
begin
  Str(Memo1.GetTextLen, txt);
  MessageDlg ('Your Document Has ' + txt + ' Characters',
  mtInformation, [mbOK], 0);
end;

//-----------------------------------------------------------------------------
procedure TForm1.Mode1Click(Sender: TObject);
begin
  if OpenDialog2.Execute Then begin
    if trans.mode.load(OpenDialog2.FileName) <> 0 then
      Application.MessageBox('Mode not loaded!', 'Error', MB_OK+MB_ICONERROR+MB_APPLMODAL)
    else
      trans.GetReady;
      StatusBar1.SimpleText := OpenDialog2.FileName;
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Numbers1Click(Sender: TObject);
begin
  TengForm2.Options.Show;
end;

//-----------------------------------------------------------------------------
procedure TForm1.About1Click(Sender: TObject);
begin
  Application.MessageBox(
    'Teng by Michal "miszka" Nowakowski, Copyright  2005', 'About Teng?', MB_OK
  );
end;

//-----------------------------------------------------------------------------
procedure TForm1.PopupMenu1Popup(Sender: TObject);
var sMemo : String;
begin
  {if some text is selected in the memo,
  enable the cut and copy commands}
  if Memo1.SelLength > 0 then begin
    Copy2.Enabled := True;
    Cut2.Enabled := True;
  end
  else begin
    Copy2.Enabled := False;
    Cut2.Enabled := False;
  end;

  {if the clipboard contains some text,
  enable the Paste command}
  if Clipboard.HasFormat (CF_TEXT) then
    Paste2.Enabled := True
  else
    Paste2.Enabled := False;

  sMemo := Memo1.Text;
  if Length(Trim(sMemo)) > 0 then begin
    SelectAll2.Enabled := True;
    Clear1.Enabled := True;
  end
  else begin
    SelectAll2.Enabled := False;
    Clear1.Enabled := False;
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Clear1Click(Sender: TObject);
begin
  Memo1.Text := '';
  modified := False;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Cut2Click(Sender: TObject);
begin
  Memo1.CutToClipboard;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Copy2Click(Sender: TObject);
begin
  Memo1.CopyToClipboard;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Paste2Click(Sender: TObject);
begin
  Memo1.PasteFromClipboard;
end;

//-----------------------------------------------------------------------------
procedure TForm1.SelectAll2Click(Sender: TObject);
begin
  Memo1.SelectAll;
end;

end.
